package org.zeroturnaround.javarebel.integration.servlet.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.javarebel.RebelServletContext;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>javax.servlet.ServletContext</code>
 * by extending it with {@link RebelServletContext} interface.
 * <p>
 * Thanks to this JavaRebel does not depend on Servlet API.
 * 
 * @author Rein Raudjärv
 */
public class ServletContextCBP extends JavassistClassBytecodeProcessor {
  
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    ctClass.addInterface(cp.get(RebelServletContext.class.getName()));
  }
}
