package org.zeroturnaround.javarebel.integration.servlet.cbp.jetty6;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.javarebel.RebelServletContext;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>org.mortbay.jetty.handler.ContextHandler</code>
 * by registering Jetty servlet context instance with JavaRebel.
 * <p>
 * The transformed class exists since Jetty 6.
 * 
 * @author Rein Raudjärv
 */
public class JettyContextHandlerCBP extends JavassistClassBytecodeProcessor {
  
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    CtMethod m = ctClass.getMethod("doStart", "()V");
    m.insertAfter(
        "org.zeroturnaround.javarebel.ServletIntegrationFactory.getInstance()" +
        "    .registerServletContext((" + RebelServletContext.class.getName() + ") $0.getServletContext());");
    
  }
}
